Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 977)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 978)
@@ -4,5 +4,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Bugfix: nzb_max is set to nzt at non-cyclic lateral boundaries
+! Bugfix: Set wall_flags_0 for inflow boundary
 !
 ! Former revisions:
@@ -608,5 +609,12 @@
 !-- Determine the maximum level of topography. Furthermore it is used for
 !-- steering the degradation of order of the applied advection scheme.
+!-- In case of non-cyclic lateral boundaries, the order of the advection
+!-- scheme is reduced at the lateral boundaries up to nzt.
     nzb_max = MAXVAL( nzb_local )
+    IF ( inflow_l .OR. outflow_l .OR. inflow_r .OR. outflow_r .OR.    &
+         inflow_n .OR. outflow_n .OR. inflow_s .OR. outflow_s )  THEN
+         nzb_max = nzt
+    ENDIF
+
 !
 !-- Consistency checks and index array initialization are only required for
@@ -1079,10 +1087,12 @@
 !--             scalar - x-direction
 !--             WS1 (0), WS3 (1), WS5 (2)
-                IF ( k <= nzb_s_inner(j,i+1) .OR. ( outflow_l .AND. i == nxl ) &
-                     .OR. ( outflow_r .AND. i == nxr ) )  THEN
+                IF ( k <= nzb_s_inner(j,i+1) .OR. ( ( inflow_l .OR. outflow_l )&
+                     .AND. i == nxl ) .OR. ( ( inflow_r .OR. outflow_r )       &
+                     .AND. i == nxr ) )  THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 0 )
                 ELSEIF ( k <= nzb_s_inner(j,i+2) .OR. k <= nzb_s_inner(j,i-1)  &
-                         .OR. ( outflow_r .AND. i == nxr-1 )                   &
-                         .OR. ( outflow_l .AND. i == nxlu  ) )  THEN
+                         .OR. ( ( inflow_r .OR. outflow_r ) .AND. i == nxr-1 ) &
+                         .OR. ( ( inflow_l .OR. outflow_l ) .AND. i == nxlu  ) &
+                       )  THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 1 )
                 ELSE
@@ -1092,11 +1102,13 @@
 !--             scalar - y-direction
 !--             WS1 (3), WS3 (4), WS5 (5)
-                IF ( k <= nzb_s_inner(j+1,i) .OR. ( outflow_s .AND. j == nys ) &
-                     .OR. ( outflow_n .AND. j == nyn ) )  THEN
+                IF ( k <= nzb_s_inner(j+1,i) .OR. ( ( inflow_s .OR. outflow_s )&
+                     .AND. j == nys ) .OR. ( ( inflow_n .OR. outflow_n )       &
+                     .AND. j == nyn ) )  THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 3 )
 !--             WS3
                 ELSEIF ( k <= nzb_s_inner(j+2,i) .OR. k <= nzb_s_inner(j-1,i)  &
-                        .OR. ( outflow_s .AND. j == nysv )                     &
-                        .OR. ( outflow_n .AND. j == nyn-1  ) )  THEN
+                         .OR. ( ( inflow_s .OR. outflow_s ) .AND. j == nysv  ) &
+                         .OR. ( ( inflow_n .OR. outflow_n ) .AND. j == nyn-1 ) &
+                       )  THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 4 )
 !--             WS5
@@ -1135,22 +1147,28 @@
 !--             WS1 (9), WS3 (10), WS5 (11)
                 IF ( k <= nzb_u_inner(j,i+1)                                  &
-                     .OR. ( outflow_r .AND. i == nxr ) )  THEN
+                     .OR. ( ( inflow_l .OR. outflow_l ) .AND. i == nxlu )     &
+                     .OR. ( ( inflow_r .OR. outflow_r ) .AND. i == nxr  )     &
+                   )  THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 9 )
                 ELSEIF ( k <= nzb_u_inner(j,i+2) .OR. k <= nzb_u_inner(j,i-1) &
-                         .OR. ( outflow_r .AND. i == nxr-1 )                  &
-                         .OR. ( outflow_l .AND. i == nxlu  ) )  THEN
+                         .OR. ( ( inflow_r .OR. outflow_r ) .AND. i == nxr-1 )&
+                         .OR. ( ( inflow_l .OR. outflow_l ) .AND. i == nxlu+1)&
+                       )  THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 10 )
                 ELSE
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 11 )
                 ENDIF
+
 !
 !--             u component - y-direction
 !--             WS1 (12), WS3 (13), WS5 (14)
-                IF ( k <= nzb_u_inner(j+1,i) .OR. ( outflow_s .AND. j == nys ) &
-                    .OR. ( outflow_n .AND. j == nyn ) )  THEN
+                IF ( k <= nzb_u_inner(j+1,i) .OR. ( ( inflow_s .OR. outflow_s )&
+                     .AND. j == nys ) .OR. ( ( inflow_n .OR. outflow_n )       &
+                     .AND. j == nyn ) )  THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 12 )
                 ELSEIF ( k <= nzb_u_inner(j+2,i) .OR. k <= nzb_u_inner(j-1,i)  &
-                    .OR. ( outflow_s .AND. j == nysv )                         &
-                    .OR. ( outflow_n .AND. j == nyn-1  ) )  THEN
+                         .OR. ( ( inflow_s .OR. outflow_s ) .AND. j == nysv  ) &
+                         .OR. ( ( inflow_n .OR. outflow_n ) .AND. j == nyn-1 ) &
+                       )  THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 13 )
                 ELSE
@@ -1181,11 +1199,13 @@
 !--             v component - x-direction
 !--             WS1 (18), WS3 (19), WS5 (20)
-                IF ( k <= nzb_v_inner(j,i+1) .OR. ( outflow_l .AND. i == nxl ) &
-                    .OR. ( outflow_r .AND. i == nxr ) )  THEN
+                IF ( k <= nzb_v_inner(j,i+1) .OR. ( ( inflow_l .OR. outflow_l )&
+                     .AND. i == nxl ) .OR. (( inflow_r .OR. outflow_r )        &
+                     .AND. i == nxr ) )  THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 18 )
 !--             WS3
                 ELSEIF ( k <= nzb_v_inner(j,i+2) .OR. k <= nzb_v_inner(j,i-1)  &
-                    .OR. ( outflow_r .AND. i == nxr-1 )                        &
-                    .OR. ( outflow_l .AND. i == nxlu  ) )  THEN
+                         .OR. ( ( inflow_r .OR. outflow_r ) .AND. i == nxr-1 ) &
+                         .OR. ( ( inflow_l .OR. outflow_l ) .AND. i == nxlu  ) &
+                       )  THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 19 )
                 ELSE
@@ -1196,9 +1216,12 @@
 !--             WS1 (21), WS3 (22), WS5 (23)
                 IF ( k <= nzb_v_inner(j+1,i)                                   &
-                     .OR. ( outflow_n .AND. j == nyn ) )  THEN
+                     .OR. ( ( inflow_s .OR. outflow_s ) .AND. i == nysv )      &
+                     .OR. ( ( inflow_n .OR. outflow_n ) .AND. j == nyn  )      &
+                   )  THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 21 )
                 ELSEIF ( k <= nzb_v_inner(j+2,i) .OR. k <= nzb_v_inner(j-1,i)  &
-                         .OR. ( outflow_s .AND. j == nysv )                    &
-                         .OR. ( outflow_n .AND. j == nyn-1  ) )  THEN
+                         .OR. ( ( inflow_s .OR. outflow_s ) .AND. j == nysv+1 )&
+                         .OR. ( ( inflow_n .OR. outflow_n ) .AND. j == nyn-1  )&
+                       )  THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 22 )
                 ELSE
@@ -1228,10 +1251,12 @@
 !--             w component - x-direction
 !--             WS1 (27), WS3 (28), WS5 (29)
-                IF ( k <= nzb_w_inner(j,i+1) .OR. ( outflow_l .AND. i == nxl ) &
-                    .OR. ( outflow_r .AND. i == nxr ) )  THEN
+                IF ( k <= nzb_w_inner(j,i+1) .OR. ( ( inflow_l .OR. outflow_l )&
+                     .AND. i == nxl ) .OR. ( ( inflow_r .OR. outflow_r )       &
+                     .AND. i == nxr ) )  THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 27 )
                 ELSEIF ( k <= nzb_w_inner(j,i+2) .OR. k <= nzb_w_inner(j,i-1)  &
-                         .OR. ( outflow_r .AND. i == nxr-1 )                   &
-                         .OR. ( outflow_l .AND. i == nxlu  ) )  THEN
+                         .OR. ( ( inflow_r .OR. outflow_r ) .AND. i == nxr-1 ) &
+                         .OR. ( ( inflow_l .OR. outflow_l ) .AND. i == nxlu  ) &
+                       )  THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 28 )
                 ELSE
@@ -1241,10 +1266,12 @@
 !--             w component - y-direction
 !--             WS1 (30), WS3 (31), WS5 (32)
-                IF ( k <= nzb_w_inner(j+1,i) .OR. ( outflow_s .AND. j == nys ) &
-                     .OR. ( outflow_n .AND. j == nyn ) )  THEN
+                IF ( k <= nzb_w_inner(j+1,i) .OR. ( ( inflow_s .OR. outflow_s )&
+                     .AND. j == nys ) .OR. ( ( inflow_n .OR. outflow_n )       &
+                     .AND. j == nyn ) )  THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 30 )
                 ELSEIF ( k <= nzb_w_inner(j+2,i) .OR. k <= nzb_w_inner(j-1,i)  &
-                         .OR. ( outflow_s .AND. j == nysv )                    &
-                         .OR. ( outflow_n .AND. j == nyn-1  ) )  THEN
+                         .OR. ( ( inflow_s .OR. outflow_s ) .AND. j == nysv  ) &
+                         .OR. ( ( inflow_n .OR. outflow_n ) .AND. j == nyn-1 ) &
+                       )  THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 31 )
                 ELSE
Index: /palm/trunk/SOURCE/init_masks.f90
===================================================================
--- /palm/trunk/SOURCE/init_masks.f90	(revision 977)
+++ /palm/trunk/SOURCE/init_masks.f90	(revision 978)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-!
+! +z0h*
 !
 ! Former revisions:
@@ -257,5 +257,5 @@
                 unit = 'psu'
 
-             CASE ( 'u*', 't*', 'lwp*', 'pra*', 'prr*', 'z0*' )
+             CASE ( 'u*', 't*', 'lwp*', 'pra*', 'prr*', 'z0*', 'z0h*' )
                 WRITE ( message_string, * ) 'illegal value for data_',&
                      'output: "', TRIM( var ), '" is only allowed', &
Index: /palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- /palm/trunk/SOURCE/init_pegrid.f90	(revision 977)
+++ /palm/trunk/SOURCE/init_pegrid.f90	(revision 978)
@@ -4,4 +4,6 @@
 ! Current revisions:
 ! -----------------
+! dirichlet/neumann and neumann/dirichlet added
+! nxlu and nysv are also calculated for inflow boundary
 !
 ! ATTENTION: nnz_x undefined problem still has to be solved!!!!!!!!
@@ -1108,7 +1110,7 @@
 !-- horizontal boundary conditions.
     IF ( pleft == MPI_PROC_NULL )  THEN
-       IF ( bc_lr == 'dirichlet/radiation' )  THEN
+       IF ( bc_lr == 'dirichlet/radiation' .OR. bc_lr == 'dirichlet/neumann' )  THEN
           inflow_l  = .TRUE.
-       ELSEIF ( bc_lr == 'radiation/dirichlet' )  THEN
+       ELSEIF ( bc_lr == 'radiation/dirichlet' .OR. bc_lr == 'neumann/dirichlet' )  THEN
           outflow_l = .TRUE.
        ENDIF
@@ -1116,7 +1118,7 @@
 
     IF ( pright == MPI_PROC_NULL )  THEN
-       IF ( bc_lr == 'dirichlet/radiation' )  THEN
+       IF ( bc_lr == 'dirichlet/radiation' .OR. bc_lr == 'dirichlet/neumann' )  THEN
           outflow_r = .TRUE.
-       ELSEIF ( bc_lr == 'radiation/dirichlet' )  THEN
+       ELSEIF ( bc_lr == 'radiation/dirichlet' .OR. bc_lr == 'neumann/dirichlet' )  THEN
           inflow_r  = .TRUE.
        ENDIF
@@ -1124,7 +1126,7 @@
 
     IF ( psouth == MPI_PROC_NULL )  THEN
-       IF ( bc_ns == 'dirichlet/radiation' )  THEN
+       IF ( bc_ns == 'dirichlet/radiation' .OR. bc_ns == 'dirichlet/neumann' )  THEN
           outflow_s = .TRUE.
-       ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
+       ELSEIF ( bc_ns == 'radiation/dirichlet' .OR. bc_ns == 'neumann/dirichlet' )  THEN
           inflow_s  = .TRUE.
        ENDIF
@@ -1132,7 +1134,7 @@
 
     IF ( pnorth == MPI_PROC_NULL )  THEN
-       IF ( bc_ns == 'dirichlet/radiation' )  THEN
+       IF ( bc_ns == 'dirichlet/radiation' .OR. bc_ns == 'dirichlet/neumann' )  THEN
           inflow_n  = .TRUE.
-       ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
+       ELSEIF ( bc_ns == 'radiation/dirichlet' .OR. bc_ns == 'neumann/dirichlet' )  THEN
           outflow_n = .TRUE.
        ENDIF
@@ -1164,16 +1166,16 @@
 
 #elif ! defined ( __parallel )
-    IF ( bc_lr == 'dirichlet/radiation' )  THEN
+    IF ( bc_lr == 'dirichlet/radiation' .OR. bc_lr == 'dirichlet/neumann' )  THEN
        inflow_l  = .TRUE.
        outflow_r = .TRUE.
-    ELSEIF ( bc_lr == 'radiation/dirichlet' )  THEN
+    ELSEIF ( bc_lr == 'radiation/dirichlet' .OR. bc_lr == 'neumann/dirichlet' )  THEN
        outflow_l = .TRUE.
        inflow_r  = .TRUE.
     ENDIF
 
-    IF ( bc_ns == 'dirichlet/radiation' )  THEN
+    IF ( bc_ns == 'dirichlet/radiation' .OR. bc_ns == 'dirichlet/neumann' )  THEN
        inflow_n  = .TRUE.
        outflow_s = .TRUE.
-    ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
+    ELSEIF ( bc_ns == 'radiation/dirichlet' .OR. bc_ns == 'neumann/dirichlet' )  THEN
        outflow_n = .TRUE.
        inflow_s  = .TRUE.
@@ -1182,12 +1184,12 @@
 
 !
-!-- At the outflow, u or v, respectively, have to be calculated for one more
-!-- grid point.
-    IF ( outflow_l )  THEN
+!-- At the inflow or outflow, u or v, respectively, have to be calculated for
+!-- one more grid point.
+    IF ( inflow_l .OR. outflow_l )  THEN
        nxlu = nxl + 1
     ELSE
        nxlu = nxl
     ENDIF
-    IF ( outflow_s )  THEN
+    IF ( inflow_s .OR. outflow_s )  THEN
        nysv = nys + 1
     ELSE
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 977)
+++ /palm/trunk/SOURCE/modules.f90	(revision 978)
@@ -4,5 +4,9 @@
 ! Current revisions:
 ! -----------------
-!
+! +c_u_m, c_u_m_l, c_v_m, c_v_m_l, c_w_m, c_w_m_l,
+! +bc_lr_dirneu, bc_lr_neudir, bc_ns_dirneu, bc_ns_neudir
+! -km_damp_x, km_damp_y, km_damp_max, outflow_damping_width
+! +z0h, z0h_av, z0h_factor, z0h1d
+! +ptdf_x, ptdf_y, pt_damping_width, pt_damping_factor 
 !
 ! Former revisions:
@@ -324,15 +328,15 @@
 
     REAL, DIMENSION(:), ALLOCATABLE ::                                         &
-          ddzu, ddzu_pres, dd2zu, dzu, ddzw, dzw, hyp, inflow_damping_factor,  &
-          km_damp_x, km_damp_y, lad, l_grid, pt_init, q_init, rdf, rdf_sc,     &
-          sa_init, ug, u_init, u_nzb_p1_for_vfc, vg, v_init, v_nzb_p1_for_vfc, &
-          w_subs, zu, zw
+          c_u_m, c_u_m_l, c_v_m, c_v_m_l, c_w_m, c_w_m_l, ddzu, ddzu_pres,     &
+          dd2zu, dzu, ddzw, dzw, hyp, inflow_damping_factor, lad, l_grid,      &
+          ptdf_x, ptdf_y, pt_init, q_init, rdf, rdf_sc, sa_init, ug, u_init,   &
+          u_nzb_p1_for_vfc, vg, v_init, v_nzb_p1_for_vfc, w_subs, zu, zw 
 
     REAL, DIMENSION(:,:), ALLOCATABLE ::                                       &
-          c_u, c_v, c_w, dzu_mg, dzw_mg, f1_mg, f2_mg, f3_mg,                  &
-          mean_inflow_profiles, pt_slope_ref, qs, qswst_remote, ts, us, z0,    &
-          flux_s_pt, diss_s_pt, flux_s_e, diss_s_e, flux_s_q, diss_s_q,        &
-          flux_s_sa, diss_s_sa, flux_s_u, flux_s_v, flux_s_w, diss_s_u,        &
-          diss_s_v, diss_s_w, total_2d_o, total_2d_a
+          c_u, c_v, c_w, diss_s_e, diss_s_pt, diss_s_q, diss_s_sa, diss_s_u,   &
+          diss_s_v, diss_s_w, dzu_mg, dzw_mg, flux_s_e, flux_s_pt, flux_s_q,   &
+          flux_s_sa, flux_s_u, flux_s_v, flux_s_w, f1_mg, f2_mg, f3_mg,        &
+          mean_inflow_profiles, pt_slope_ref, qs, qswst_remote, total_2d_a,    &
+          total_2d_o, ts, us, z0, z0h
 
     REAL, DIMENSION(:,:), ALLOCATABLE, TARGET ::                               &
@@ -347,10 +351,10 @@
 
     REAL, DIMENSION(:,:,:), ALLOCATABLE ::                                     &
-          canopy_heat_flux, cdc, d, de_dx, de_dy, de_dz, diss, lad_s, lad_u,   &
-          lad_v, lad_w, lai, l_wall, p_loc, sec, sls, tend, u_m_l, u_m_n,      &
-          u_m_r, u_m_s, v_m_l, v_m_n, v_m_r, v_m_s, w_m_l, w_m_n, w_m_r,       &
-          w_m_s, flux_l_pt, diss_l_pt, flux_l_e, diss_l_e, flux_l_q, diss_l_q, &
-          flux_l_sa, diss_l_sa, flux_l_u, flux_l_v, flux_l_w, diss_l_u,        &
-          diss_l_v, diss_l_w
+          canopy_heat_flux, cdc, d, de_dx, de_dy, de_dz, diss, diss_l_e,       &
+          diss_l_pt, diss_l_q, diss_l_sa, diss_l_u, diss_l_v, diss_l_w,        &
+          flux_l_e, flux_l_pt, flux_l_q, flux_l_sa, flux_l_u, flux_l_v,        &
+          flux_l_w, lad_s, lad_u, lad_v, lad_w, lai, l_wall, p_loc, sec, sls,  &
+          tend, u_m_l, u_m_n, u_m_r, u_m_s, v_m_l, v_m_n, v_m_r, v_m_s, w_m_l, &
+          w_m_n, w_m_r, w_m_s
 
     REAL, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                             &
@@ -388,5 +392,6 @@
 
     REAL, DIMENSION(:,:), ALLOCATABLE ::  lwp_av, precipitation_rate_av,       &
-                                          qsws_av, shf_av,ts_av, us_av, z0_av
+                                          qsws_av, shf_av,ts_av, us_av, z0_av, &
+                                          z0h_av
 
     REAL, DIMENSION(:,:,:), ALLOCATABLE, TARGET :: &
@@ -549,6 +554,6 @@
                 netcdf_data_format = 2, ngsrb = 2, nsor = 20, &
                 nsor_ini = 100, n_sor, normalizing_region = 0, &
-                nz_do3d = -9999, outflow_damping_width = -1, &
-                pch_index = 0, prt_time_count = 0, recycling_plane, runnr = 0, &
+                nz_do3d = -9999, pch_index = 0, prt_time_count = 0, &
+                recycling_plane, runnr = 0, &
                 skip_do_avs = 0, subdomain_size, terminate_coupled = 0, &
                 terminate_coupled_remote = 0, timestep_count = 0
@@ -582,7 +587,9 @@
 
     LOGICAL ::  adjust_mixing_length = .FALSE., avs_output = .FALSE., &
-                bc_lr_cyc =.TRUE., bc_lr_dirrad = .FALSE., &
+                bc_lr_cyc =.TRUE., bc_lr_dirneu = .FALSE., &
+                bc_lr_dirrad = .FALSE., bc_lr_neudir = .FALSE., &
                 bc_lr_raddir = .FALSE., bc_ns_cyc = .TRUE., &
-                bc_ns_dirrad = .FALSE., bc_ns_raddir = .FALSE., &
+                bc_ns_dirneu = .FALSE., bc_ns_dirrad = .FALSE., &
+                bc_ns_neudir = .FALSE., bc_ns_raddir = .FALSE., &
                 call_psolver_at_all_substeps = .TRUE., &
                 cloud_droplets = .FALSE., cloud_physics = .FALSE., &
@@ -659,5 +666,5 @@
              f = 0.0, fs = 0.0, g = 9.81, inflow_damping_height = 9999999.9, &
              inflow_damping_width = 9999999.9, kappa = 0.4, km_constant = -1.0,&
-             km_damp_max = -1.0, lad_surface = 0.0,  &
+             lad_surface = 0.0,  &
              leaf_surface_concentration = 0.0, long_filter_factor = 0.0, &
              mask_scale_x = 1.0, mask_scale_y = 1.0, mask_scale_z = 1.0, &
@@ -670,4 +677,5 @@
              phi = 55.0, prandtl_number = 1.0, &
              precipitation_amount_interval = 9999999.9, prho_reference, &
+             pt_damping_factor = 0.0, pt_damping_width = 0.0, &
              pt_reference = 9999999.9, pt_slope_offset = 0.0, &
              pt_surface = 300.0, pt_surface_initial_change = 0.0, &
@@ -700,5 +708,5 @@
              ups_limit_v = 0.0, ups_limit_w = 0.0, vg_surface = 0.0, &
              v_bulk = 0.0, v_gtrans = 0.0, wall_adjustment_factor = 1.8, &
-             z_max_do2d = -1.0
+             z_max_do2d = -1.0, z0h_factor = 1.0
 
     REAL ::  do2d_xy_last_time(0:1) = -1.0, do2d_xz_last_time(0:1) = -1.0, &
@@ -1057,5 +1065,5 @@
                 qs1d, simulated_time_1d = 0.0, time_pr_1d = 0.0, &
                 time_run_control_1d = 0.0, ts1d, us1d, usws1d, usws1d_m, &
-                vsws1d, vsws1d_m, z01d
+                vsws1d, vsws1d_m, z01d, z0h1d
 
 
Index: /palm/trunk/SOURCE/parin.f90
===================================================================
--- /palm/trunk/SOURCE/parin.f90	(revision 977)
+++ /palm/trunk/SOURCE/parin.f90	(revision 978)
@@ -4,5 +4,7 @@
 ! Current revisions:
 ! -----------------
-!
+! -km_damp_max, outflow_damping_width
+! +pt_damping_factor, pt_damping_width
+! +z0h_factor
 !
 ! Former revisions:
@@ -168,5 +170,5 @@
              inflow_damping_height, inflow_damping_width, &
              inflow_disturbance_begin, inflow_disturbance_end, &
-             initializing_actions, km_constant, km_damp_max, lad_surface, &
+             initializing_actions, km_constant, lad_surface, &
              lad_vertical_gradient, lad_vertical_gradient_level, &
              leaf_surface_concentration, long_filter_factor, &
@@ -175,8 +177,9 @@
              netcdf_precision, neutral, ngsrb, nsor, &
              nsor_ini, nx, ny, nz, ocean, omega, omega_sor, &
-             outflow_damping_width, overshoot_limit_e, overshoot_limit_pt, &
+             overshoot_limit_e, overshoot_limit_pt, &
              overshoot_limit_u, overshoot_limit_v, overshoot_limit_w, &
              passive_scalar, pch_index, phi, plant_canopy, prandtl_layer, &
-             prandtl_number, precipitation, psolver, pt_reference, pt_surface, &
+             prandtl_number, precipitation, psolver, pt_damping_factor, &
+             pt_damping_width, pt_reference, pt_surface, &
              pt_surface_initial_change, pt_vertical_gradient, &
              pt_vertical_gradient_level, q_surface, q_surface_initial_change, &
@@ -200,5 +203,5 @@
              uv_heights, u_bulk, u_profile, vg_surface, vg_vertical_gradient, &
              vg_vertical_gradient_level, v_bulk, v_profile, wall_adjustment, &
-             wall_heatflux, wall_humidityflux, wall_scalarflux
+             wall_heatflux, wall_humidityflux, wall_scalarflux, z0h_factor
 
 
Index: /palm/trunk/SOURCE/poismg.f90
===================================================================
--- /palm/trunk/SOURCE/poismg.f90	(revision 977)
+++ /palm/trunk/SOURCE/poismg.f90	(revision 978)
@@ -7,5 +7,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! bc_lr/ns_dirneu/neudir added
+!
 !
 ! Former revisions:
@@ -1229,10 +1230,10 @@
 !--       outflow conditions have to be used on all PEs after the switch,
 !--       because then they have the total domain.
-          IF ( bc_lr_dirrad )  THEN
+          IF ( bc_lr_dirrad .OR. bc_lr_dirneu )  THEN
              inflow_l  = .TRUE.
              inflow_r  = .FALSE.
              outflow_l = .FALSE.
              outflow_r = .TRUE.
-          ELSEIF ( bc_lr_raddir )  THEN
+          ELSEIF ( bc_lr_raddir .OR. bc_lr_neudir )  THEN
              inflow_l  = .FALSE.
              inflow_r  = .TRUE.
@@ -1241,10 +1242,10 @@
           ENDIF
 
-          IF ( bc_ns_dirrad )  THEN
+          IF ( bc_ns_dirrad .OR. bc_ns_dirneu )  THEN
              inflow_n  = .TRUE.
              inflow_s  = .FALSE.
              outflow_n = .FALSE.
              outflow_s = .TRUE.
-          ELSEIF ( bc_ns_raddir )  THEN
+          ELSEIF ( bc_ns_raddir .OR. bc_ns_neudir )  THEN
              inflow_n  = .FALSE.
              inflow_s  = .TRUE.
@@ -1316,7 +1317,7 @@
 
           IF ( pleft == MPI_PROC_NULL )  THEN
-             IF ( bc_lr_dirrad )  THEN
+             IF ( bc_lr_dirrad .OR. bc_lr_dirneu )  THEN
                 inflow_l  = .TRUE.
-             ELSEIF ( bc_lr_raddir )  THEN
+             ELSEIF ( bc_lr_raddir .OR. bc_lr_neudir )  THEN
                 outflow_l = .TRUE.
              ENDIF
@@ -1324,7 +1325,7 @@
 
           IF ( pright == MPI_PROC_NULL )  THEN
-             IF ( bc_lr_dirrad )  THEN
+             IF ( bc_lr_dirrad .OR. bc_lr_dirneu )  THEN
                 outflow_r = .TRUE.
-             ELSEIF ( bc_lr_raddir )  THEN
+             ELSEIF ( bc_lr_raddir .OR. bc_lr_neudir )  THEN
                 inflow_r  = .TRUE.
              ENDIF
@@ -1332,7 +1333,7 @@
 
           IF ( psouth == MPI_PROC_NULL )  THEN
-             IF ( bc_ns_dirrad )  THEN
+             IF ( bc_ns_dirrad .OR. bc_ns_dirneu )  THEN
                 outflow_s = .TRUE.
-             ELSEIF ( bc_ns_raddir )  THEN
+             ELSEIF ( bc_ns_raddir .OR. bc_ns_neudir )  THEN
                 inflow_s  = .TRUE.
              ENDIF
@@ -1340,7 +1341,7 @@
 
           IF ( pnorth == MPI_PROC_NULL )  THEN
-             IF ( bc_ns_dirrad )  THEN
+             IF ( bc_ns_dirrad .OR. bc_ns_dirneu )  THEN
                 inflow_n  = .TRUE.
-             ELSEIF ( bc_ns_raddir )  THEN
+             ELSEIF ( bc_ns_raddir .OR. bc_ns_neudir )  THEN
                 outflow_n = .TRUE.
              ENDIF
Index: /palm/trunk/SOURCE/prandtl_fluxes.f90
===================================================================
--- /palm/trunk/SOURCE/prandtl_fluxes.f90	(revision 977)
+++ /palm/trunk/SOURCE/prandtl_fluxes.f90	(revision 978)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! roughness length for scalar quantities z0h added
 !
 ! Former revisions:
@@ -96,7 +96,7 @@
 !
 !--             Stable stratification
-                ts(j,i) = kappa * ( pt(k+1,j,i) - pt(k,j,i) ) / (          &
-                                  LOG( z_p / z0(j,i) ) +                   &
-                                  5.0 * rif(j,i) * ( z_p - z0(j,i) ) / z_p &
+                ts(j,i) = kappa * ( pt(k+1,j,i) - pt(k,j,i) ) / (           &
+                                  LOG( z_p / z0h(j,i) ) +                   &
+                                  5.0 * rif(j,i) * ( z_p - z0h(j,i) ) / z_p &
                                                                 )
              ELSE
@@ -104,8 +104,8 @@
 !--             Unstable stratification
                 a = SQRT( 1.0 - 16.0 * rif(j,i) )
-                b = SQRT( 1.0 - 16.0 * rif(j,i) * z0(j,i) / z_p )
-
-                ts(j,i) = kappa * ( pt(k+1,j,i) - pt(k,j,i) ) /  (         &
-                          LOG( z_p / z0(j,i) ) -                           &
+                b = SQRT( 1.0 - 16.0 * rif(j,i) * z0h(j,i) / z_p )
+
+                ts(j,i) = kappa * ( pt(k+1,j,i) - pt(k,j,i) ) /  (          &
+                          LOG( z_p / z0h(j,i) ) -                           &
                           2.0 * LOG( ( 1.0 + a ) / ( 1.0 + b ) ) )
              ENDIF
@@ -308,7 +308,7 @@
 !
 !--                Stable stratification
-                   qs(j,i) = kappa * ( q(k+1,j,i) - q(k,j,i) ) / (         &
-                                  LOG( z_p / z0(j,i) ) +                   &
-                                  5.0 * rif(j,i) * ( z_p - z0(j,i) ) / z_p &
+                   qs(j,i) = kappa * ( q(k+1,j,i) - q(k,j,i) ) / (          &
+                                  LOG( z_p / z0h(j,i) ) +                   &
+                                  5.0 * rif(j,i) * ( z_p - z0h(j,i) ) / z_p &
                                                                  )
                 ELSE
@@ -316,8 +316,8 @@
 !--                Unstable stratification
                    a = SQRT( 1.0 - 16.0 * rif(j,i) ) 
-                   b = SQRT( 1.0 - 16.0 * rif(j,i) * z0(j,i) / z_p ) 
+                   b = SQRT( 1.0 - 16.0 * rif(j,i) * z0h(j,i) / z_p ) 
  
-                   qs(j,i) = kappa * ( q(k+1,j,i) - q(k,j,i) ) /   (   &
-                             LOG( z_p / z0(j,i) ) -                    &
+                   qs(j,i) = kappa * ( q(k+1,j,i) - q(k,j,i) ) /   (        &
+                             LOG( z_p / z0h(j,i) ) -                        &
                               2.0 * LOG( (1.0 + a ) / ( 1.0 + b ) ) )
                 ENDIF
